theory QDesImp imports Main begin

text {*
 Attempt at a constructive design spec, the idea is to
 make @term{enq} and @term{deq} constructors: 
 *}

datatype 'a q = mtQ | enq "'a" "'a q" | deq "'a q"

text {* 
 Again, we have a problem with observational 
 equivalence in the last axiom-- obviously, two queues are only
 equal up to the same contents.
 *}


fun   cont    :: "'a q => 'a list"
where "cont (mtQ) = []"
    | "cont (enq a q) = cont q @ [a]"
    | "cont (deq q) =  tl (cont q)"

definition isEmpty :: "'a q => bool" 
where "isEmpty q == (cont q = [])"

definition front   :: "'a q => 'a"
where "front q == hd (cont q)"

lemma empty: "isEmpty mtQ"
  by (simp add: isEmpty_def)

lemma notEmpty: "~ (isEmpty (enq a q))"
  by (simp add: isEmpty_def)


lemma hd1: "~ (List.null xs) ==> hd (xs@ys) = hd xs"
  apply (auto simp add: hd_append null_def)
  done

lemma front: "front (enq a q) = (if isEmpty q then a else front q)"
  apply (unfold front_def, unfold isEmpty_def)
  apply (auto simp add: hd1)
  done

lemma deq: "cont (deq (enq a q)) = cont(if isEmpty q then mtQ else enq a (deq q))"
  apply (unfold isEmpty_def)
  apply (auto)
  done

end
